EAPI EAPI_WEAK const Efl_Event_Description _EFL_TASK_EVENT_EXIT =
   EFL_EVENT_DESCRIPTION("exit");

void _efl_task_priority_set(Eo *obj, Efl_Task_Data *pd, Efl_Task_Priority priority);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_task_priority_set, EFL_FUNC_CALL(priority), Efl_Task_Priority priority);

Efl_Task_Priority _efl_task_priority_get(const Eo *obj, Efl_Task_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_task_priority_get, Efl_Task_Priority, 0);

int _efl_task_exit_code_get(const Eo *obj, Efl_Task_Data *pd);


static Eina_Value
__eolian_efl_task_exit_code_get_reflect(const Eo *obj)
{
   int val = efl_task_exit_code_get(obj);
   return eina_value_int_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_task_exit_code_get, int, 0);

void _efl_task_flags_set(Eo *obj, Efl_Task_Data *pd, Efl_Task_Flags flags);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_task_flags_set, EFL_FUNC_CALL(flags), Efl_Task_Flags flags);

Efl_Task_Flags _efl_task_flags_get(const Eo *obj, Efl_Task_Data *pd);

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_task_flags_get, Efl_Task_Flags, 8 /* Efl.Task_Flags.exit_with_parent */);
EAPI EAPI_WEAK EFL_FUNC_BODY(efl_task_run, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_task_end);

Efl_Object *_efl_task_efl_object_constructor(Eo *obj, Efl_Task_Data *pd);


void _efl_task_efl_object_destructor(Eo *obj, Efl_Task_Data *pd);


void _efl_task_efl_object_parent_set(Eo *obj, Efl_Task_Data *pd, Efl_Object *parent);


static Eina_Bool
_efl_task_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_TASK_EXTRA_OPS
#define EFL_TASK_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_task_priority_set, _efl_task_priority_set),
      EFL_OBJECT_OP_FUNC(efl_task_priority_get, _efl_task_priority_get),
      EFL_OBJECT_OP_FUNC(efl_task_exit_code_get, _efl_task_exit_code_get),
      EFL_OBJECT_OP_FUNC(efl_task_flags_set, _efl_task_flags_set),
      EFL_OBJECT_OP_FUNC(efl_task_flags_get, _efl_task_flags_get),
      EFL_OBJECT_OP_FUNC(efl_task_run, NULL),
      EFL_OBJECT_OP_FUNC(efl_task_end, NULL),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_task_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_task_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_parent_set, _efl_task_efl_object_parent_set),
      EFL_TASK_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"exit_code", NULL, __eolian_efl_task_exit_code_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_task_class_desc = {
   EO_VERSION,
   "Efl.Task",
   EFL_CLASS_TYPE_REGULAR_NO_INSTANT,
   sizeof(Efl_Task_Data),
   _efl_task_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_task_class_get, &_efl_task_class_desc, EFL_LOOP_CONSUMER_CLASS, NULL);
